
import org.junit.Test;

import static org.junit.Assert.*;

public final class CommandParserTest {
    
    @Test
    public void testParseNoParametersNoPayload() {
        Command expected = new Command(Command.Type.CONNECT, null);
        assertEquals(expected, CommandParser.parse(expected.toString()));
    }

    
    @Test
    public void testParseOneParameterNoPayload() {
        Command expected = new Command(Command.Type.JOIN, "java", null, null);
        assertEquals(expected, CommandParser.parse(expected.toString()));
    }

    
    @Test
    public void testParseTwoParametersNoPayload() {
        Command expected = new Command(Command.Type.KICK, "java", "Troll",
                null);
        assertEquals(expected, CommandParser.parse(expected.toString()));
    }

    
    /*
     * This method illustrates how to write a test case where we expect a
     * failure. With the [expected] parameter on the [@Test] annotation, we tell
     * JUnit that this test should succeed if it throws
     * [IllegalArgumentException], and fail if it throws a different
     * exception or none at all.
     */
    @Test(expected = IllegalArgumentException.class)
    public void testParseThreeParametersNoPayload() {
        CommandParser.parse("JOIN foo bar baz");
    }
    
}
