import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.Timer;

/**
 * <p>Initializes and starts a {@link ServerBackend}, a {@link ServerModel},
 * and a very basic UI to indicate that the server is running. When that UI is
 * closed, using the standard operating system "red X", the server is shut
 * down.</p>
 *
 * <p>You do not need to read or modify this file for the purposes of this
 * assignment.</p>
 */
final class ServerMain {
    public static void main(String[] args) {
        final JFrame frame = new JFrame("PennPals server");
        JLabel label1 = new JLabel("Test");
        label1.setText(
                "<html>Hello, my name is Bob.<br/>I will be your server for " +
                        "the evening.</html>");
        label1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        frame.add(label1);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setSize(new Dimension(250, 100));

        ServerModel state = new ServerModel();
        final ServerBackend server = new ServerBackend(state);
        final Timer timer = new Timer(100, null);
        timer.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (!frame.isDisplayable() || !server.isRunning()) {
                    frame.dispose();
                    server.stop();
                    timer.stop();
                }
            }
        });
        timer.start();
        new Thread(server, "Connection acceptor").start();

        frame.setVisible(true);
    }

    private ServerMain() {
    }
}
